<?php declare(strict_types=1);
namespace MyTestNamespace;
require __DIR__ . '/bootstrap.php';
require __DIR__ . '/testClasses.php';
use function Grifart\AssertFunction\{assertSignature, nullable, params};
use Tester\Assert;

$fn = function(?T1 $t1, ?T2 $t2): ?T3 {return new T3;};
assertSignature($fn, params(nullable(T1::class), nullable(T2::class)), nullable(T3::class));

// missing optional check
Assert::exception(function () use ($fn) {
	assertSignature($fn, params(T1::class, nullable(T2::class)), nullable(T3::class));
}, \AssertionError::class /* todo: assert message */);

Assert::exception(function () use ($fn) {
	assertSignature($fn, params(nullable(T1::class), T2::class), nullable(T3::class));
}, \AssertionError::class /* todo: assert message */);

Assert::exception(function () use ($fn) {
	assertSignature($fn, params(nullable(T1::class), nullable(T2::class)), T3::class);
}, \AssertionError::class /* todo: assert message */);

// Wrong return type type
Assert::exception(function () use ($fn) {
	assertSignature($fn, params(nullable(T1::class), nullable(T2::class)), nullable(T2::class));
}, \AssertionError::class /* todo: assert message */);

// Wrong parameter type
Assert::exception(function () use ($fn) {
	assertSignature($fn, params(nullable(T1::class), nullable(T1::class)), nullable(T3::class));
}, \AssertionError::class /* todo: assert message */);
