<?php declare(strict_types=1);
namespace MyTestNamespace;
require __DIR__ . '/bootstrap.php';
require __DIR__ . '/testClasses.php';
use function Grifart\AssertFunction\{assertSignature, nullable, params};
use Tester\Assert;


$f1 = function(T1 $t1, T2 $t2): T3 {return new T3;};

// Positive scenario
assertSignature($f1, params(T1::class, T2::class), T3::class);
assertSignature($f1, [T1::class, T2::class], T3::class); // alternative syntax

// Optional by accident: parameter
Assert::exception(function () use ($f1) {
	assertSignature($f1, params(nullable(T1::class), T2::class), T3::class);
}, \AssertionError::class);

// Optional by accident: return type
Assert::exception(function () use ($f1) {
	assertSignature($f1, params(T1::class, T2::class), nullable(T3::class));
//	assertFunction($f1, [params(T1::class, T2::class) => nullable(T3::class)]);
}, \AssertionError::class);
