<?php declare(strict_types=1);
namespace MyTestNamespace;
require __DIR__ . '/bootstrap.php';
require __DIR__ . '/testClasses.php';
use function Grifart\AssertFunction\{assertSignature, nullable, params};
use Tester\Assert;
$position = 'tests/fn.assertSignature.wrongNumberOfArguments.phpt:9';

$f1 = function(T1 $t1, T2 $t2): T3 {return new T3;};

// Wrong number of arguments
Assert::exception(
	function () use ($f1) {
		assertSignature($f1, params(T1::class), T3::class);
	},
	\AssertionError::class,
	"$position Given wrong number of parameters. Expected 1, 2 given."
);

Assert::exception(
	function () use ($f1) {
		assertSignature($f1, params(T1::class, T2::class, T1::class), T3::class);
	},
	\AssertionError::class,
	"$position Given wrong number of parameters. Expected 3, 2 given."
);
